<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\ProposalLikeCount;
use App\Managers\ProposalLikeCount\ProposalLikeCountModel;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\DB;
use App\Managers\Proposal\ProposalManager;
use App\Http\Helper\Helper;
class ProposalLikeCountManager extends ProposalLikeCountModel
{
    public function __construct()
    {
         $this->userManager = new UserManager();
         
         $this->helper = new Helper();
    }

    public function addLike($id, $noOfLikes)
    {
        $this->proposal = new ProposalManager();
        DB::beginTransaction();
        try 
        {
            $data['proposal_id'] = $id;
            $data['no_of_likes'] = $noOfLikes;
            $data['user_id'] = Session::get('general');
            $data['UUID'] = $this->helper->addUuid();
            $res = $this->insert($data);
            if(!$res)
            {
                return 0;
            }
            
            $updateProposalLike = $this->proposal->where('UUID', $id)->update(array('no_of_likes' => DB::raw('no_of_likes+' . $noOfLikes)));
            if(!$updateProposalLike)
            {
                return 0;
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function updateData($data, $UUID)
    {
        $this->proposal = new ProposalManager();
        return $this->proposal->where('UUID', $UUID)->update($data);
    }
    
    public function getTotalLikesByUser($proposalID, $userID)
    {
        return $this->select(DB::raw('SUM(no_of_likes) AS total_likes'))->where('user_id', $userID)->where('proposal_id', $proposalID)->first();
    }
}